package cat.hack3.codingtests.marsrover;


import java.util.logging.Logger;

/**
 * Notice that the representation is the following:
 * Latitude is Y, starts from 0 on the top and goes down incrementally
 * Longitude is X, starts from 0 on the left and goes to right incrementally
 * 0  1   2   3
 * 1  11  12  13
 * 2  12  22  23
 * 3  13  23  33
 */
public class Coordinates {
    private int latitude;
    private int longitude;
    private Logger logger = Logger.getLogger(Coordinates.class.getName());

    public static Coordinates of(int latitude, int longitude) {
        return new Coordinates(latitude, longitude);
    }

    public Coordinates(int latitude, int longitude) {
        this.latitude = latitude;
        this.longitude = longitude;
    }

    public Coordinates incrementSouth() {
        latitude++;
        logger.info("incremented South latitude, now is "+latitude);
        return this;
    }

    @Override
    public boolean equals(Object o) {
        if (this == o) return true;
        if (o == null || getClass() != o.getClass()) return false;

        Coordinates that = (Coordinates) o;

        if (latitude != that.latitude) return false;
        return longitude == that.longitude;
    }

    @Override
    public String toString() {
        return "Coordinates{" +
                "latitude=" + latitude +
                ", longitude=" + longitude +
                '}';
    }
}
